
#include "Grid.h"

using namespace GraphicsLib;

Grid::Grid(int W,int H,int Xs,int Zs)
{
// store values
Width=W;
Depth=H;
Xsteps=Xs;
Zsteps=Zs;
// allocate the new grid points
GridPoints = new Point3[Xsteps*Zsteps];
// index used to point into the array of points
int index=0;
// calculate the dimensions of the grid so it is centered at 0,0,0
GLfloat MaxX=Width/2.0;
GLfloat MinX=-MaxX;
GLfloat MaxZ=Depth/2.0;
GLfloat MinZ=-MaxZ;
// now determine the size of each steps in the x and the z
GLfloat xstep=Width/Xsteps;
GLfloat zstep=Depth/Zsteps;
// variables used to store the current point values
GLfloat xpos;
GLfloat zpos=MinZ;
// now create the gp point lattice as a series of equi distant points
for(int z=0; z<Zsteps; z++)
	{
	xpos=MinX;
    for (int x=0; x<Xsteps; x++)
    	{
		GridPoints[index].set(xpos, 0.0,zpos);
		xpos+=xstep;
    	index++;
    	}
	zpos+=zstep;
	}
			
}
Grid::~Grid()
{
delete [] GridPoints;	
}
		
void Grid::Draw(void)
{
int index=0;
// wireframe draw
// creat the display list
    for(int Y=0; Y<Zsteps-1; Y++)
	{
	glBegin(GL_TRIANGLE_STRIP);
	for(int X=0; X<Xsteps-1; X++)
	{
	// check for ends
    if(X <=Xsteps-2)
	{
		// calculate the normals for the 3 triangles
		Vector n1=
		CalcNormal (GridPoints[index],GridPoints[index+Xsteps],GridPoints[index+1]);
 		Vector n2=
		CalcNormal (GridPoints[index+1],GridPoints[index+Xsteps],GridPoints[index+Xsteps+1]);
		Vector n3=
		CalcNormal (GridPoints[index+Xsteps],GridPoints[index],GridPoints[index+Xsteps+1]);

		// normalise them and reverse n1 and n2 as they face the wrong way
        n1.normalize();
		n2.normalize();
		n3.normalize();
        n1=-n1; //.Reverse();
        n2=-n2; //.Reverse();

		// set the normal
        n1.Normal();
		// draw the vertex
        GridPoints[index].Vertex();
		// and if using textures se the texture cords
		n2.Normal();
		GridPoints[index+Xsteps].Vertex();
		n3.Normal();
		GridPoints[index+1].Vertex();
		//tri 2
		n2.Normal();
		GridPoints[index+1].Vertex();

		n3.Normal();
		GridPoints[index+Xsteps].Vertex();

		n1.Normal();
		GridPoints[index+Xsteps+1].Vertex();

		index++;
		}// end if 
		
		}// end for X
		index+=1;
		glEnd();
        }// end for Z
}

 