#include <iostream>
#include <math.h>
#include "GraphicsLib.h"
#include "Grid.h"
using namespace std;
using namespace GraphicsLib;


Grid *myGrid;

// The global camera
// the values to spin the main window by in x y and z
int spinxface = 0 ;
int spinyface = 0 ;
int spinzface = 0 ;
int  origx,origy,origz,RotateXY,RotateXZ=0;
int Rotate;
// draw function
bool update=false;

void display()
{
// clear the current buffer
glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
// save the current transformation matrix
// turn on the lights
glPushMatrix();
	//rotate the global scene based on the mouse rotations
    glRotated	( (GLdouble) spinxface, 1.0, 0.0, 0.0 ) ;
    glRotated	( (GLdouble) spinyface, 0.0, 1.0, 0.0 ) ;
    glRotated	( (GLdouble) spinzface, 0.0, 0.0, 1.0 ) ;
	// create pointers to the begining and end of the particle list
	myGrid->Draw();
glPopMatrix();
// render the scene
glutSwapBuffers();
}


/*! InitGL set's up the opengl drawing state */
void InitGL()
{
glClearColor(0.0f, 0.0f, 0.0f, 1.0f);			   // Grey Background
// render things smoothly
glShadeModel(GL_SMOOTH);
// enable depth testing for drawing
glEnable(GL_DEPTH_TEST);
// enable the default light
glEnable(GL_LIGHT0);
// set the ambient colour to dark grey
GLfloat AmbColour[]={0.2,0.2,0.2};
glLightModelfv(GL_LIGHT_MODEL_AMBIENT,AmbColour);

glMatrixMode(GL_PROJECTION);
	glFrustum(-2.0, 2.0, -2.0, 2.0, 3.0, 200);
	glMatrixMode(GL_MODELVIEW);
	glTranslatef(0.0, 0.0, -60.0);

glEnable(GL_LIGHTING);

}

void KeyPressed(unsigned char ch, int x, int y)
{
  switch (ch)
  {
  // ESC key to exit program
		  case 27 : exit(0); break;
		  case 'w' : glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); break;
		  case 'W' : glPolygonMode(GL_FRONT_AND_BACK,GL_FILL); break;
		  case 'p' : glPolygonMode(GL_FRONT_AND_BACK,GL_POINT); break;
		  case 'u' : update ^=true; break;
  }
  
  // tell the system we need to redisplay
 glutPostRedisplay();
}



// camera controls
void SpecialKeyPressed(int key, int x, int y)
{
    switch (key)
    {
    }
 //redisplay the scene
glutPostRedisplay();
}


// mouse rotation funciton
void motion ( int x, int y )
{
 if (Rotate) {
	 spinyface = ( spinyface + (x - origx) ) % 360 ;
	 spinxface = ( spinxface + (y - origy) ) % 360 ;
	 origx = x;
	 origy = y;
	 glutPostRedisplay();
  }
}

/* The button callback is called when a mouse key is pressed */

static void Button(int button, int down, int x, int y)
{
Rotate = 0;
  switch(button)
  {
  case GLUT_LEFT_BUTTON:
	 if (down == GLUT_DOWN)
        {
		origx = x;
		origy = y;
		Rotate = 1;
        }
     else Rotate = 0;
   break;
   }
}


void Update(int i)
{
if(update ==true)
{
static float inc=0.0;
int index=0;
for(int z=0; z<myGrid->Zsteps; z++)
	{
	float offset = sin(myGrid->GridPoints[index].z);

	 for (int x=0; x<myGrid->Xsteps; x++)
    	{
		myGrid->GridPoints[index].y = (sin(myGrid->GridPoints[index].x + inc))*RandomNum(2.0) + offset;
		// to do write some code to modify the y component of the Grid
		// to some new value (cos(x) for example)	
		index++;
    	}
	}
inc +=0.02;

glutPostRedisplay();
}
glutTimerFunc(30,Update,0);
// re-load the timer to call update again in 1 milisecond
}

// application mai loop
int main(int argc, char **argv)
{
	glutInit(&argc, argv);
// if args passed on the command line process
    glutInitDisplayMode(GLUT_DEPTH | GLUT_RGBA | GLUT_DOUBLE);
	glutInitWindowSize(800,800);
    glutCreateWindow("wave");
	//set the time to the current time
    //load the glut callbacks
    glutDisplayFunc(display);
    //glutIdleFunc(idle);
	
	glutMouseFunc(Button);
    glutMotionFunc(motion);
    glutKeyboardFunc(KeyPressed);
    glutSpecialFunc(SpecialKeyPressed);
	//initialise opengl
	InitGL();
	glutTimerFunc(30,Update,0);
	myGrid = new Grid(100,100,50,50);
	glutMainLoop();
	//this never gets called due to glutmainloop not exiting properly
    return 1;
}


//end of file




