#ifndef __CANVAS_H__
#define __CANVAS_H__

#include "types.h"
#include <math.h>
#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include "Point2.h"
#include "RealRect.h"
#include "IntRect.h"
#include "Colour.h"
namespace GraphicsLib{
class Canvas
{
public:
		Canvas(GLint width, GLint height); //constructor
        void setWindow(Real l, Real r, Real b, Real t);
        void setViewport(GLint l, GLint r, GLint b, GLint t);
        IntRect getViewport(void); //divulge the viewport data
        RealRect getWindow(void); // divulge the window data
        Real getWindowAspectRatio(void);
        void clearScreen();
        void setBackgroundColour(Real r, Real g, Real b);
        void setBackgroundColour(Colour col);
		void setColour(Real r, Real g, Real b);
        void setColour(Colour col);
		void lineTo(Real x, Real y);
        void lineTo(Point2 p);
        void moveTo(Real x, Real y);
        void moveTo(Point2 p);
		void moveRel(Real dx, Real dy);
		void drawRel(Real dx,Real dy);
		void CPshow(void);	
		Point2 CP;     
private:
        //current position in the world
     IntRect viewport;  //the current window
     RealRect window;   //the current viewport

} ;
};
#endif
