#ifndef __IMAGE_H__
#define __IMAGE_H__
#ifdef _WINDOWS_
#include <windows.h>
#endif
#include <GL/glut.h>
#include <math.h>
#include "types.h"
/*! a class to read in a bmp file and use it for a texture */
/*!
* This code has been modified from the lesson below, I have borrowed the
* BMP loader and added it to my image class Jon Macey <BR>
*
* 
* Simon Werner, 23.07.2000 <BR>
* 
* OpenGL lesson 18. This lesson is the Linux version based on lesson 18 
* written by NeHe (Jeff Molofee), http://nehe.gamedev.net/ . It is also 
* based on other ports done by Richard Campbell.
* This code includes snippets from lessons 5, 6, 7 and 8. 
<BR> AS SOLARIS IS DIFFERENT ENDIAN THAN INTEL WE NEED TWO
VERSIONS OF THE LOADER to use the SOLARIS Version use 
* <B> \#define SOLARIS
 
 */

namespace GraphicsLib {

class Image
{
private :
/*! the size of the image in the X direction */
	GLuint sizeX;
/*! the size of the image in the Y direction */
	GLuint sizeY;

public :
/*! Constructor using no parameters */
	Image();
	~Image();
	/*! Constructor passing the file to load
	 * \param char *fname the name of the file to load */
	Image(char *fname);
	/*!get the X sixe of the image
	 * \return GLuint sizeX */
	GLuint getX(){return sizeX;}
	/*!get the Y size of the image
	 * \return GLuint sizeY */
	GLuint getY(){return sizeY;}
	/*!return a pointer to the image data
	 * \returns GLubyte *data */

	GLubyte *GetImage(){return data;}
	/*!method to load the bmp file
	 * \return GLint 0 load ok 1 fail */

	GLint loadImage(char *filename);

    GLuint GetFromXY(int x, int y);

    /*!set the image as a texture */
	unsigned int setTexture(void);

/*! A pointer to the start of the image data */
	GLubyte *data;

};

}
#endif
