#ifndef __INTRECT_H__
#define __INTRECT_H__

#include <math.h>
#include <GL/gl.h>
#include "types.h"
/*! aligned rectangle with integer coordinates used for viewport
 */
namespace GraphicsLib {
class IntRect  //aligned rectangle with integer coordinates, used for viewport
{
public :
	GLint l, r, b, t;
					
	/*!constructor defaults to 0,0 100,100 */
	IntRect() {l = 0; r=100; b=0; t=100;} //constructors
	/*!constructor with parameters
	 * \param int left left extent
	 * \param int right right extent
	 * \param int bottom bottom
	 * \param int top top */
	IntRect(GLint left, GLint right, GLint bottom, GLint top)
		{l = left; r=right; b=bottom; t=top;}
	/*!set the rectangle to new value 
	 * \param int left left extent
	 * \param int right right extent
	 * \param int bottom bottom
	 * \param int top top */
	 
	void set(GLint left, GLint right, GLint bottom, GLint top)
	{
		l=left; r=right; b=bottom; t=top;
	}
	/*! draw the rectangle using opengl */
	void draw(void); //draw this rectangle using OpenGL
	/*!get the left value
	 * \returns int l the left value */


};

}
#endif
