#ifndef __MANIPULATOR__
#define __MANIPULATOR__
#include "Point3.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include "types.h"
namespace GraphicsLib
{
enum ManipModes {ManipRotate,ManipTranslate,ManipScale};
enum ManipActiveAxis{ManipXAxis,ManipYAxis,ManipZAxis,ManipNone};

class Manipulator
{
 private :

/*! The name of the current ponit used in the selection process */
    GLuint Xmanip;
	GLuint Ymanip;
	GLuint Zmanip;
	void DrawTrans();
	void DrawScale();
	void DrawRotate();
	bool Active;


 public :
// manipulator modes
	ManipModes mode;
	ManipActiveAxis activeAxis;
	Point3 Center;
	Point3 NewPos;
	Real xrot;
	Real yrot;
	Real zrot;
	Real xscale;
	Real yscale;
	Real zscale;
	GLuint SelectedAxisNames[4];

	Manipulator();
	Manipulator(ManipModes Mode);
	~Manipulator();
	void Draw();
	void SelectionDraw();
	void SetActive(int val);
};

} // end of namespace
#endif

