#ifndef __PATHCAMERA_H__
#define __PATHCAMERA_H__
#include <iostream>
#include "Camera.h"
#include "CurveFollow.h"
#include <math.h>
#include "types.h"
namespace GraphicsLib {
class PathCamera : public Camera{

private:
	enum DIRECTION{CAMFWD,CAMBWD};	
    DIRECTION dir;
    Real Step;
public:
	Real EyecurvePoint;
    Real LookcurvePoint;
	CurveFollow *EyePath;
    CurveFollow *LookPath;
    PathCamera(Point3 eye, Point3 look, Vector Up,CurveFollow eyePath, CurveFollow lookPath,Real step);
    PathCamera(Point3 eye, Point3 look, Vector Up,Point3 *eyePoints, Point3 *lookPoints,Real step);
    PathCamera(Point3 eye, Point3 look, Vector Up,std::string fname,Real step);		   
    ~PathCamera();
    void Update(void);
    void UpdateLooped(void);
    void DrawPaths(void);
	void LoadPath(std::string fname);


};
}
#endif






