#ifndef __POINT2_H__
#define __POINT2_H__

#include "types.h"
#include <math.h>
#include <iostream>
#include <GL/gl.h>

namespace GraphicsLib {
/*! a simple cartesian point class using x and y as float values */
class Point2   //single point w/ floating point coordinates
{
public:

	/*!The x position of the point */
	Real x;
	/*!The y position of the poinit */
	Real y;
	
		
	/*!constructor x=y=0.0 */
	Point2() {x = y = 0.0f;} //constructor 1
	/*!constructor passing in x,y
	 * \param float xx value to set x
	 * \param float yy value to set y */
	Point2(Real xx, Real yy) {x=xx; y=yy;} //constructor 2
	/*!set point to a new point 
	 * \param float xx new x value
	 * \param float yy new y value */
	void set(Real xx, Real yy) {x=xx; y=yy;}
	/*!draw draws a point at the current position */
	void draw(void);

	Point2 operator * (Real rhs);
	Point2 operator / (Real rhs);
	Point2 operator / (Point2 rhs);

friend std::ostream& operator<<(std::ostream& output, const GraphicsLib::Point2& s);
/*! >> insertion operator to read in the point data x -> y -> z
   \param std::istream & input the instream class pointer
   \param const Point3 s the point to read in to
*/
friend std::istream& operator>>(std::istream& input, GraphicsLib::Point2 &s);


private:
};

}

#endif
