#ifndef __REALRECT_H__
#define __REALRECT_H__


#include <math.h>
#include <GL/gl.h>
#include "types.h"
/*! class to contain the points of a rectangle as Reals useful to store
 * windows and viewports as an encapsulated whole */
namespace GraphicsLib {
class RealRect   //simlar to IntRect but w/ Realing points & used for world window
{
public:
	/*!the left value */
	Real l;
	/*!the right value */
	Real r;
	/*!the bottom value */
	Real b;
	/*! the top value */
	Real t;

	/*! constructor to with default value of 0,0 100,100 */
	RealRect() {l = 0; r=100; b=0; t=100;} //constructors
	/*! constructor with t,l b,r parameters
	 * \param Real left the left edge of the rectangle
	 * \param Real right the right edge of the rectangle
	 * \param Real bottom the bottom edge of the rectangle
	 * \param Real top the top edge of the rectangle */
	RealRect(Real left, Real right, Real bottom, Real top)
		{l = left; r=right; b=bottom; t=top;}
	/*! set set the rectangles extents
	 * \param Real left the left extent
	 * \param Real right the right extent
	 * \param Real bottom the bottom
	 * \param Real top the top */
	void set(Real left, Real right, Real bottom, Real top)
	{
		l=left; r=right; b=bottom; t=top;
	}
	/*!draw draws the rectangle in opengl */
	void draw(void); //draw this rectangle using OpenGL
};
}
#endif
