//---------------------------------------------------------------------------

#ifndef SpotLightH
#define SpotLightH
//---------------------------------------------------------------------------
#include "Vector.h"
#include "Light.h"
#include <math.h>
#include "types.h"
// Subclass of Light, this class encapsulates a local spot light
namespace GraphicsLib {
class SpotLight : public Light
{
private :
	Real SpotDir[3];
	Real CutoffAngle;
	Real SpotExponent;
	Real ConstantAtten;
	Real LinearAtten;
	Real QuadraticAtten;
	Point3 pos;
	Point3 aim;
	Vector dir;
													
		
		
public:
    SpotLight(GLint number, Point3 Pos, Vector Dir, Colour col);
	SpotLight(GLint number, Point3 Pos, Point3 Aim, Colour col);

	void Show(void);
    void Enable(void);
	void SetParams( Real Cutoff,Real Exponent,
			   Real Constant, Real Linear,
			   Real Quadratic);

	void SpotLight::Aim(Point3 Pos);

};
}
#endif

