#ifndef __MYASSERT_H__
#define __MYASSERT_H__

//first check to see if assert is defined and undef it
/*! this file is to replace the std C++ Assert functions
 * These are turned on and off by specifying the _DEBUG flag
 * in the make file (-D_DEBUG in the FLAGS line.
 * These are simmilar to the normal assert macros but don't exit
 * the program as our asserts are not usually fatal. Also can use the 
 * assert in the TODO list to flag methods which have not yet been
 * implimented.
 */
#ifdef assert
	#undef assert
#endif

#ifdef ASSERT
	#undef ASSERT
#endif
// now if we are in debug mode use these macros
#if defined(_DEBUG)

#define assert(a) 						\
   if(!(a))                               \
   {                                   \
   cerr << "Assertion failed :"<< #a   \
     <<"\nFailure occured on line "    \
     << __LINE__ << " of source file :" \
     <<"\n  \""<<__FILE__<<"\"\n";     \
   }
#define ASSERT(a,str)				\
	if(!(a))							\
	{								\
	 cerr << "Assertion failed :"<< #a   \
	 << " " << #str					   \
     <<"\nFailure occured on line "    \
     << __LINE__ << " of source file :" \
     <<"\n  \""<<__FILE__<<"\"\n";     \
   }

#else
// define release macros
 #define assert ;// these do nothing
 #define ASSERT(a,str)

#endif // #if defined(_DEBUG)

#endif // __MYASSERT_H__
