#include "Colour.h"

using namespace std;
using namespace GraphicsLib;
void Colour ::add(Colour src, Colour refl)
{ // add the product of source color and reflection coefficient
	r   += src.r   * refl.r;
	g += src.g * refl.g;
	b  += src.b  * refl.b;
	a +=src.a * refl.a;
}

void Colour :: build4tuple(Real v[])
{// load 4-tuple with this color:
	v[0] = r; v[1] = g; v[2] = b; v[3] =a;
}


Colour Colour::operator +(const Colour &rhs)
{
Colour ret;
ret.r=r+rhs.r; ret.g=g+rhs.g; ret.b=b+rhs.b; ret.a=a+rhs.a;
return ret;
}

Colour Colour::operator -(const Colour &rhs)
{
Colour ret;
ret.r=r-rhs.r; ret.g=g-rhs.g; ret.b=b-rhs.b; ret.a=a-rhs.a;
return ret;
}

void Colour::operator +=(const Colour &rhs)
{
r+=rhs.r; g+=rhs.g; b+=rhs.b; a+=rhs.a;
}
Colour Colour::operator *(const Colour &rhs)
{
Colour ret;
ret.r=r*rhs.r; ret.g=g*rhs.g; ret.b=b*rhs.b; ret.a=a*rhs.a;
return ret;
}
Colour Colour::operator *(Real rhs)
{
Colour ret;
ret.r=r*rhs; ret.g=g*rhs; ret.b=b*rhs; ret.a=a*rhs;
return ret;
}
void Colour::operator *=(const Colour &rhs)
{
r*=rhs.r; g*=rhs.g; b*=rhs.b; a*=rhs.a;
}

void Colour::operator *=(Real rhs)
{
r*=rhs; g*=rhs; b*=rhs; a*=rhs;

}

void Colour::Use(void)
{
glColor4f(r,g,b,a);
}


ostream& GraphicsLib::operator<<(ostream& output, const Colour & s)
{
 return output<<"["<<s.r<<","<<s.g<<","<<s.b<<","<<s.a<<"]";
}

istream& GraphicsLib::operator>>(std::istream& input, Colour s)
{
return input >> s.r >> s.g >> s.b>>s.a;

}





