#include "CurveFollow.h"
using namespace GraphicsLib;
// constructor
CurveFollow::CurveFollow(Point3 p[4])
{
//copy the points passed in to the local points
for(int i=0; i<4; i++)
    CP[i].set(p[i]);
}

CurveFollow::~CurveFollow()
{
// nothing needed here
}
void CurveFollow::SetCP(int index, Point3 P)
{
// method to change any of the points in the array
//could add an assert but not done now to increase speed
CP[index].set(P);

}
Point3 CurveFollow::GetPointOnCurve(Real t)
{
//return the current point on the curve at time T this is done with the deCasteljau algorithm

Point3 A=Lerp(CP[0],CP[1],t);
Point3 B=Lerp(CP[1],CP[2],t);
Point3 C=Lerp(CP[2],CP[3],t);
Point3 Pt=Lerp(Lerp(A,B,t),Lerp(B,C,t),t);
return Pt;
}



void CurveFollow::DrawCurve(void)
{
//preserve the current transformation matrix
glDisable(GL_LIGHTING);
glPushMatrix();
//set the colour
   glColor3f(1,1,0);

// loop from 0.0 to 1.0 to draw the curve
//incriment in a small enough step to create a smooth curve

for(Real t=0.0f; t<1.0f; t+=0.002f)
	{
	// get the current point on the curve for time t
    Point3 Pt=GetPointOnCurve(t);
    //now draw the point using using GL_POINTSD
    glBegin(GL_POINTS);
       glVertex3f(Pt.x,Pt.y,Pt.z);
    glEnd();

    }
 
 for(int i=0; i<4; i++)
 	{
    glPushMatrix();
    	CP[i].Translate();
        glutSolidSphere(0.02,12,12);
    glPopMatrix();
    
    }
 glEnable(GL_LIGHTING);
//restore the transformation matrix
glPopMatrix();

}

