#include "Manipulator.h"


using namespace GraphicsLib;


Manipulator::Manipulator()
{
mode=ManipTranslate;
Center.set(0,0,0);
NewPos=Center;
xrot=yrot=zrot=0.0f;
xscale=yscale=zscale=0.0f;

}


Manipulator::Manipulator(ManipModes Mode)
{
mode=ManipTranslate;
Center.set(0,0,0);
NewPos=Center;
xrot=yrot=zrot=0.0f;
xscale=yscale=zscale=0.0f;
}
Manipulator::~Manipulator()
{

}


void Manipulator::Draw()
{
	switch (mode)
	{
	 case  ManipTranslate :
		  DrawTrans();
	 break;

	 case ManipRotate :
		  DrawRotate();
	 break;
	case ManipScale :
		DrawScale();
	break;


	}

}

void Manipulator::DrawTrans()
{
glPushMatrix();
	Center.Translate();
glDisable(GL_LIGHTING);
glBegin(GL_LINES);
    glColor3f(1.0f,0.0f,0.0f); //x
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.8f,0.0f,0.0f);

	glColor3f(0.0f,1.0f,0.0f); //y
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.8f,0.0f);
	glColor3f(0.0f,0.0f,1.0f); //z
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.8f);
glEnd();
//cone for x
glPushMatrix();
	glColor3f(1.0f,0.0f,0.0f);
   glTranslatef(0.8f,0.0f,0.0f);

   glRotatef(90.0f,0,1,0);
   glutSolidCone(0.04f,0.2f,8,8);
glPopMatrix();
//cone for y
glColor3f(0.0f,1.0f,0.0f);
glPushMatrix();
   glTranslatef(0.0f,0.8f,0.0f);

   glRotatef(-90.0f,1,0,0);
   glutSolidCone(0.04f,0.2f,8,8);
glPopMatrix();

glColor3f(0.0f,0.0f,1.0f);
// cone for z
glPushMatrix();
   glTranslatef(0.0f,0.0f,0.8f);

   glRotatef(-90.0f,0,0,1);
   glutSolidCone(0.04f,0.2f,8,8);
glPopMatrix();
glEnable(GL_LIGHTING);
glPopMatrix();


}
void Manipulator::DrawScale()
{
glPushMatrix();
	Center.Translate();
glDisable(GL_LIGHTING);
glBegin(GL_LINES);
    glColor3f(1.0f,0.0f,0.0f); //x
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.8f,0.0f,0.0f);

	glColor3f(0.0f,1.0f,0.0f); //y
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.8f,0.0f);
	glColor3f(0.0f,0.0f,1.0f); //z
    glVertex3f(0.0f,0.0f,0.0f);
	glVertex3f(0.0f,0.0f,0.8f);
glEnd();
//cube for x
glPushMatrix();
	glColor3f(1.0f,0.0f,0.0f);
   glTranslatef(0.8f,0.0f,0.0f);
   glutSolidCube(0.08f);
glPopMatrix();
//cube for y
glColor3f(0.0f,1.0f,0.0f);
glPushMatrix();
   glTranslatef(0.0f,0.8f,0.0f);
   glutSolidCube(0.08f);
glPopMatrix();

glColor3f(0.0f,0.0f,1.0f);
// cube for z
glPushMatrix();
   glTranslatef(0.0f,0.0f,0.8f);
   glutSolidCube(0.08f);
glPopMatrix();
glEnable(GL_LIGHTING);
glPopMatrix();

}
void Manipulator::DrawRotate()
{
GLUquadricObj *quadObj;
quadObj = gluNewQuadric();
gluQuadricDrawStyle(quadObj, GLU_FILL);
  gluQuadricNormals(quadObj, GLU_SMOOTH);

glPushMatrix();
	Center.Translate();
	glDisable(GL_LIGHTING);
  	glPushMatrix();
		glColor3f(1.0,0.0,0.0);
		gluCylinder(quadObj, 0.8, 0.8, 0.02, 40, 2);
  	glPopMatrix();
	glPushMatrix();
  		glColor3f(0.0,1.0,0.0);
  		glRotatef(-90.0f,1,0,0);
  		gluCylinder(quadObj, 0.8, 0.8, 0.02, 40, 2);
 	glPopMatrix();

	glPushMatrix();
  		glColor3f(0.0,0.0,1.0);
  		glRotatef(-90.0f,0,0,1);
		glRotatef(-90.0,1,0,0);
  		gluCylinder(quadObj, 0.8, 0.8, 0.02, 40, 2);
  	glPopMatrix();
glEnable(GL_LIGHTING);
glPopMatrix();

}

void Manipulator::SelectionDraw()
{
GLUquadricObj *quadObj;
glInitNames();
	glPushName(0);
	glPushMatrix();
		Center.Translate();
	glDisable(GL_LIGHTING);

switch(mode)
	{
	case ManipTranslate :
	case ManipScale :
		//cube for x
		glPushMatrix();
			glLoadName(10000);
			glTranslatef(0.8f,0.0f,0.0f);
			glutSolidCube(0.4f);
		glPopMatrix();
		//cube for y
		glPushMatrix();
			glLoadName(10001);
			glTranslatef(0.0f,0.8f,0.0f);
			glutSolidCube(0.4f);
		glPopMatrix();
		// cube for z
		glPushMatrix();
			glLoadName(10002);
			glTranslatef(0.0f,0.0f,0.8f);
			glutSolidCube(0.4f);
		glPopMatrix();
	break;
	case ManipRotate :
		quadObj = gluNewQuadric();
		gluQuadricDrawStyle(quadObj, GLU_FILL);
		gluQuadricNormals(quadObj, GLU_SMOOTH);
		glPushMatrix();
			glLoadName(10000);
			gluCylinder(quadObj, 0.8, 0.8, 0.1, 40, 2);
		glPopMatrix();
		glPushMatrix();
			glLoadName(10001);
			glRotatef(-90.0f,1,0,0);
			gluCylinder(quadObj, 0.8, 0.8, 0.1, 40, 2);
		glPopMatrix();
		glPushMatrix();
			glLoadName(10002);
			glRotatef(-90.0f,0,0,1);
			glRotatef(-90.0,1,0,0);
			gluCylinder(quadObj, 0.8, 0.8, 0.1, 40, 2);
		glPopMatrix();
	break;
	} // end switch
glEnable(GL_LIGHTING);
glPopMatrix();

}


void Manipulator::SetActive(int val)
{
switch(val)
	{
	case 10000 :
		activeAxis=ManipXAxis;
		break;
	case 10001 :
		activeAxis=ManipYAxis;
		break;
	case 10002 :
		activeAxis=ManipZAxis;
		break;
	default :
		activeAxis = ManipNone;
	break;
	} // end switch
}




