#include "Material.h"
#include <iostream>
#include <fstream>
using namespace std;
using namespace GraphicsLib;

 
void Material :: setDefault()
{
//	textureType = 0; // for none
//	numParams = 0;
	reflectivity = transparency = 0.0;
	SpeedOfLight = specularExponent = 1.0;
	specularFraction = 0.0;
	surfaceRoughness = 0.0;
	ambient.set(0.1f,0.1f,0.1f);
	diffuse.set(0.8f,0.8f,0.8f);
	specular.set(0,0,0);
	emissive.set(0,0,0);
}
 Material::Material(STDMAT mat)
{
 specularExponent = materials[mat][9];
 ambient.set(materials[mat][0],materials[mat][1],materials[mat][2]);
 diffuse.set(materials[mat][3],materials[mat][4],materials[mat][5]);
 specular.set(materials[mat][6],materials[mat][7],materials[mat][8]);
 emissive.set(0,0,0);

}
void Material :: Change(STDMAT mat)
{
 specularExponent = materials[mat][9];
 ambient.set(materials[mat][0],materials[mat][1],materials[mat][2]);
 diffuse.set(materials[mat][3],materials[mat][4],materials[mat][5]);
 specular.set(materials[mat][6],materials[mat][7],materials[mat][8]);
 emissive.set(0,0,0);
 this->Use();
}

Material::Material(int mat)
{
 specularExponent = materials[mat][9];
 ambient.set(materials[mat][0],materials[mat][1],materials[mat][2]);
 diffuse.set(materials[mat][3],materials[mat][4],materials[mat][5]);
 specular.set(materials[mat][6],materials[mat][7],materials[mat][8]);
 emissive.set(0,0,0);

}




void Material :: set(Material m)
{
	textureType = m.textureType;
	numParams = m.numParams;
	for(int i = 0; i < numParams; i++) params[i] = m.params[i];
	transparency = m.transparency;
	SpeedOfLight = m.SpeedOfLight;
	reflectivity = m.reflectivity;
	specularExponent = m.specularExponent;
	specularFraction = m.specularFraction;
	surfaceRoughness = m.surfaceRoughness;
	Priority=1.0;	
	ambient.set(m.ambient);
	diffuse.set(m.diffuse);
	specular.set(m.specular);
	emissive.set(m.emissive);
}
void Material :: set(Material *m)
{
	textureType = m->textureType;
	numParams = m->numParams;
	for(int i = 0; i < numParams; i++) params[i] = m->params[i];
	transparency = m->transparency;
	SpeedOfLight = m->SpeedOfLight;
	reflectivity = m->reflectivity;
	specularExponent = m->specularExponent;
	specularFraction = m->specularFraction;
	surfaceRoughness = m->surfaceRoughness;
	ambient.set(m->ambient);
	diffuse.set(m->diffuse);
	specular.set(m->specular);
	emissive.set(m->emissive);
	Priority=1.0;
}

void Material::Use()
{
	Real amb[4],diff[4],spec[4], emiss[4];
	//Real zero[] = {0,0,0,1};
	ambient.build4tuple(amb); // fill the array
	diffuse.build4tuple(diff);
	specular.build4tuple(spec);
	emissive.build4tuple(emiss);
	ambient.a=transparency;
	diffuse.a=transparency;
	specular.a=transparency;
	emissive.a=transparency;
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb);
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diff);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec);
	glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,emiss);
	glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,specularExponent);
    

}
void Material::Use(Real transp)
{
	Real amb[4],diff[4],spec[4], emiss[4];
	//Real zero[] = {0,0,0,1};
	ambient.build4tuple(amb); // fill the array
	diffuse.build4tuple(diff);
	specular.build4tuple(spec);
	emissive.build4tuple(emiss);
	amb[3]=transp; diff[3]=transp;
	spec[3]=transp; emiss[3]=transp; 
	
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb);
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diff);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec);
	glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,emiss);
	glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,specularExponent);
}

Material::Material(string fname)
{
ifstream FileIn;
FileIn.open(fname.c_str(),ios::in);

if (!FileIn.is_open())
    {
     cout <<"File : "<<fname<<" Not found Exiting "<<endl;
	 exit(1);
	}

    FileIn>>ambient;
	FileIn>>diffuse;
	FileIn>>specular;
	FileIn>>emissive;
	
    
FileIn.close();
}
void Material::Load(string fname)
{

}



