#include "PathCamera.h"
#include <fstream>
using namespace std;
using namespace GraphicsLib;
PathCamera::PathCamera(Point3 eye, Point3 look, Vector Up,CurveFollow eyePath, CurveFollow lookPath,Real step)
    	      :Camera(eye,look,Up)
{
dir=CAMFWD;
EyecurvePoint=0.0;
LookcurvePoint=0.0;
EyePath= new CurveFollow(eyePath);
LookPath= new CurveFollow(lookPath);
Step=step;
}

PathCamera::PathCamera(Point3 eye, Point3 look, Vector Up,Point3 *eyePoints, Point3 *lookPoints,Real step)
    	      :Camera(eye,look,Up)
{
dir=CAMFWD;
EyecurvePoint=0.0;
LookcurvePoint=0.0;
EyePath= new CurveFollow(eyePoints);
LookPath= new CurveFollow(lookPoints);
Step=step;
}



PathCamera::PathCamera(Point3 eye, Point3 look, Vector Up,string fname,Real step)
    	      :Camera(eye,look,Up)
{
dir=CAMFWD;
EyecurvePoint=0.0;
LookcurvePoint=0.0;

ifstream FileIn;
FileIn.open(fname.c_str(),ios::in);

if (!FileIn.is_open())
    {
     cout <<"File : "<<fname<<" Not found Exiting "<<endl;
	 exit(1);
	}
Point3 eyePoints[4];
Point3 lookPoints[4];

for(int i=0; i<4; i++)
	FileIn >> eyePoints[i]; 
for(int i=0; i<4; i++)
	FileIn>> lookPoints[i]; 

FileIn.close();
    
    
    
EyePath= new CurveFollow(eyePoints);
LookPath= new CurveFollow(lookPoints);
Step=step;
}
void PathCamera::LoadPath(std::string fname)
{
dir=CAMFWD;
EyecurvePoint=0.0;
LookcurvePoint=0.0;

ifstream FileIn;
FileIn.open(fname.c_str(),ios::in);

if (!FileIn.is_open())
    {
     cout <<"File : "<<fname<<" Not found Exiting "<<endl;
	 exit(1);
	}
Point3 eyePoint;
Point3 lookPoint;

for(int i=0; i<4; i++)
	{
    FileIn >> eyePoint; 
    EyePath->SetCP(i,eyePoint);
    }
for(int i=0; i<4; i++)
	{
    FileIn>> lookPoint; 
    LookPath->SetCP(i,lookPoint);
    }

FileIn.close();
    

}


PathCamera::~PathCamera()
{

}
void PathCamera::Update(void)
{
Point3 ept=EyePath->GetPointOnCurve(EyecurvePoint);
Point3 lpt=LookPath->GetPointOnCurve(LookcurvePoint);

Eye=ept;
Look=lpt;
n.set(Eye.x - Look.x, Eye.y - Look.y,Eye.z - Look.z);
u.set(UP.cross(n));
v.set(n.cross(u));
u.normalize(); v.normalize(); n.normalize();

setModelViewMatrix();

EyecurvePoint+=Step;
if(EyecurvePoint>1.0)
	EyecurvePoint=0.0;
LookcurvePoint+=Step;
if(LookcurvePoint>1.0)
	LookcurvePoint=0.0;


}

void PathCamera::UpdateLooped(void)
{
Point3 ept=EyePath->GetPointOnCurve(EyecurvePoint);
Point3 lpt=LookPath->GetPointOnCurve(LookcurvePoint);

Eye=ept;
Look=lpt;
n.set(Eye.x - Look.x, Eye.y - Look.y,Eye.z - Look.z);
u.set(UP.cross(n));
v.set(n.cross(u));
u.normalize(); v.normalize(); n.normalize();

setModelViewMatrix();
if(dir==CAMFWD)
{
EyecurvePoint+=Step;
if(EyecurvePoint>=1.0)
	dir=CAMBWD;
    
    
LookcurvePoint+=Step;
if(LookcurvePoint>=1.0)
	dir=CAMBWD;
}

else
{
EyecurvePoint-=Step;
if(EyecurvePoint<=Step)
	{
    dir=CAMFWD;
    }
    
    
LookcurvePoint-=Step;
if(LookcurvePoint<=Step)
	dir=CAMFWD;
}



}



void PathCamera::DrawPaths(void)
{
EyePath->DrawCurve();
LookPath->DrawCurve();
}

