#include "ai.h"
using namespace std;
using namespace GraphicsLib;


void removeAI(AIcluster* whatCluster, AIthoughtList_Iter whatAI_Iter) {
//has to be called from the parent cluster
	if (whatAI_Iter->second->AIname == "CLUSTER") {
		AIthoughtList_Iter tempIter;
		AIcluster* ptheCluster = dynamic_cast<AIcluster*>(whatAI_Iter->second);
		for (tempIter = ptheCluster->AIthoughtList.begin(); tempIter != ptheCluster->AIthoughtList.end(); tempIter++) {
			removeAI(ptheCluster,tempIter);
		}
	}

	whatCluster->AIthoughtList.erase(whatAI_Iter);

}

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//AIcluster methods


//methods for adding AIthought modules
AIcluster* AIcluster::addAI_cluster(bot* pBot_in, float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , (new AIcluster())) ); // add a pointer to the AI list

	AIcluster* tempCluster = dynamic_cast<AIcluster*>(tempIter->second);

	tempCluster->pCluster = this; //set the parent cluster to be
	tempCluster->Cluster_Iter = tempIter;

	tempCluster->pBot = pBot; // set the bot that the cluster effects to be the bot the parent cluster effects
	tempCluster->clusterLvl = clusterLvl + 1;  //make the cluster level 1 greater than the parents cluster level

	tempCluster->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in;

	//if the cluster is the root cluster then dont apply its weight to the children
	if (clusterLvl == 0) tempCluster->weight = weight_in;
  	else tempCluster->weight = weight_in * weight;

	tempCluster->activityState = activityState_in;
	tempCluster->AIname = "CLUSTER";

	tempCluster->decideThoughts();

	cout << "BOT[" << pBot->universeID << "]: Adding CLUSTER ai element - priority:" << priority_in << endl;

	return tempCluster;
}

seekBot* AIcluster::addAI_SeekBot(bot* ptargetBot_in, float t_in, float failureDistance_in, bool flee_in, float weight_in, int priority_in, int activityState_in) {

	//make the new AI state a seekbot class

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new seekBot()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	seekBot* tempSeekBot = dynamic_cast<seekBot*>(tempIter->second);

	tempSeekBot->pCluster = this;
	tempSeekBot->Cluster_Iter = tempIter;

	tempSeekBot->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempSeekBot->weight = weight_in;
  	else tempSeekBot->weight = weight_in * weight;

	tempSeekBot->activityState = activityState_in;
	if (flee_in) tempSeekBot->AIname = "FLEEBOT";
	else tempSeekBot->AIname = "SEEKBOT";

	tempSeekBot->flee = flee_in;
	tempSeekBot->targetBot = ptargetBot_in;
	tempSeekBot->t = t_in;
	tempSeekBot->failureDistance = failureDistance_in;

	cout << "BOT[" << pBot->universeID << "]: Adding SEEKBOT ai element - priority:" << priority_in << endl;

	return tempSeekBot;
}

seekPoint* AIcluster::addAI_SeekPoint(Vector target_in, float failureDistance_in, bool flee_in, float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new seekPoint()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	seekPoint* tempSeekPoint = dynamic_cast<seekPoint*>(tempIter->second);

	tempSeekPoint->pCluster = this;
	tempSeekPoint->Cluster_Iter = tempIter;

	tempSeekPoint->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempSeekPoint->weight = weight_in;
  	else tempSeekPoint->weight = weight_in * weight;

	tempSeekPoint->activityState = activityState_in;
	if (flee_in) tempSeekPoint->AIname = "FLEEPOINT";
	else tempSeekPoint->AIname = "SEEKPOINT";

	tempSeekPoint->flee = flee_in;
	tempSeekPoint->target = target_in;
	tempSeekPoint->failureDistance = failureDistance_in;

	cout << "BOT[" << pBot->universeID << "]: Adding SEEKPOINT ai element - priority:" << priority_in << endl;

	return tempSeekPoint;

}

seperation* AIcluster::addAI_Seperation(float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new seperation()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	seperation* tempSeperation = dynamic_cast<seperation*>(tempIter->second);

	tempSeperation->pCluster = this;
	tempSeperation->Cluster_Iter = tempIter;

	tempSeperation->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempSeperation->weight = weight_in;
  	else tempSeperation->weight = weight_in * weight;

	tempSeperation->activityState = activityState_in;
	tempSeperation->AIname = "SEPERATION";

	cout << "BOT[" << pBot->universeID << "]: Adding SEPERATION ai element - priority:" << priority_in << endl;

	return tempSeperation;

}

cohesion* AIcluster::addAI_Cohesion(float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new cohesion()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	cohesion* tempCohesion = dynamic_cast<cohesion*>(tempIter->second);

	tempCohesion->pCluster = this;
	tempCohesion->Cluster_Iter = tempIter;

	tempCohesion->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempCohesion->weight = weight_in;
  	else tempCohesion->weight = weight_in * weight;

	tempCohesion->activityState = activityState_in;
	tempCohesion->AIname = "COHESION";

	cout << "BOT[" << pBot->universeID << "]: Adding COHESION ai element - priority:" << priority_in << endl;

	return tempCohesion;

}

alignment* AIcluster::addAI_Alignment(float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new alignment()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	alignment* tempAlignment = dynamic_cast<alignment*>(tempIter->second);

	tempAlignment->pCluster = this;
	tempAlignment->Cluster_Iter = tempIter;

	tempAlignment->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempAlignment->weight = weight_in;
  	else tempAlignment->weight = weight_in * weight;

	tempAlignment->activityState = activityState_in;
	tempAlignment->AIname = "ALIGNMENT";

	cout << "BOT[" << pBot->universeID << "]: Adding ALIGNMENT ai element - priority:" << priority_in << endl;

	return tempAlignment;

}

followPath* AIcluster::addAI_followPath(path* whatPath, float radius_in, bool dirInvert_in, float weight_in, int priority_in, int activityState_in) {

	AIthoughtList_Iter tempIter;
	tempIter = AIthoughtList.insert( AIthoughtList_Pair(priority_in  , new followPath()) ); // add a pointer to the AI list

	//set the attributes for the new seekbot ai element
	followPath* tempfollowPath = dynamic_cast<followPath*>(tempIter->second);

	tempfollowPath->pCluster = this;
	tempfollowPath->Cluster_Iter = tempIter;

	tempfollowPath->priority = priority_in;
	if (priority_in > maxPriority) maxPriority = priority_in; //set the max priority if the new one is greater

	if (clusterLvl == 0) tempfollowPath->weight = weight_in;
  	else tempfollowPath->weight = weight_in * weight;

	tempfollowPath->activityState = activityState_in;
	tempfollowPath->AIname = "FOLLOWPATH";

	tempfollowPath->thePath = whatPath;
	tempfollowPath->thePath->radius = radius_in;
	tempfollowPath->dirInvert = dirInvert_in;
	if (!tempfollowPath->dirInvert) tempfollowPath->currPointID = 0; else tempfollowPath->currPointID = tempfollowPath->thePath->pointList.size()-1;

	cout << "BOT[" << pBot->universeID << "]: Adding FOLLOWPATH ai element - priority:" << priority_in << endl;

	return tempfollowPath;

}

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

void AIcluster::printAIlist() {

	cout << "BOT[" << pBot->universeID << "] current AI list:" << endl;
	AIthoughtList_Iter tempIter;
	for (tempIter = AIthoughtList.begin(); tempIter != AIthoughtList.end(); tempIter++) {
		cout << "  > priority:" << tempIter->first << " - " << (tempIter->second)->AIname << endl;
	}

}

void AIcluster::decideThoughts() {

	//add thoughts to the cluster automatically

}
void AIcluster::AIaction(AIthought *pWhatThought) {

	if (PRINTAI) cout << "   > p[" << pWhatThought->priority << "] " << pWhatThought->AIname << " -> weight:" << pWhatThought->weight << "   activity:" << pWhatThought->activityState << endl;
	// if this AI module is active then do its action
	if (pWhatThought->activityState == 0) pWhatThought->action();

	//if its a success then do the success thing, else do the failure thing
	if (pWhatThought->activityState == 1) pWhatThought->success();
	else if (pWhatThought->activityState == 2) pWhatThought->failure();

}

// required methods ***********************************
void AIcluster::action() {
	AIthoughtList_Iter tempIter;// = AIthoughtList.lower_bound(0);

	for (tempIter = AIthoughtList.lower_bound(0); tempIter != AIthoughtList.upper_bound(0); ++tempIter) {
		// do every thought that has a priority of 0, without cancelling out the thoughts above
		AIaction(tempIter->second);
	}


	for (int i=1; i<=maxPriority; i++) {
		//for every level of priority in this cluster

		if (AIthoughtList.count(i) != 0) {
			//if there is an element of this priority
			for (tempIter = AIthoughtList.lower_bound(i); tempIter != AIthoughtList.upper_bound(i); ++tempIter) {
				//step through every thought with the current priority
				AIaction(tempIter->second);

			}
			break; // quit the for loop - dont have any more thoughts of lower priority
		}

	}
}

void AIcluster::success() {

}

void AIcluster::failure() {

}

int AIcluster::updateActivity() {
	return 0;
}

AIcluster::~AIcluster() {
	//destroy an AI cluster
	AIthoughtList_Iter tempIter;
	for (tempIter = AIthoughtList.begin(); tempIter != AIthoughtList.end(); tempIter++) {
	//	removeAI(this, tempIter);
	}
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//seekBot methods

void seekBot::action() {

	calcDistance(); //recalculate how far from the target we are
	//add a weighted aimforce towards the target to the bots totalForce
	//drawFailDist();
	Vector tempForce;
	if (flee) {
		tempForce = -1* (pCluster->pBot->aimForce(targetBot->futurePosition(t) , pCluster->pBot->pBotType->max_force) * weight);
		if (PRINTAI) cout << "     > fleeing ";
	} else {
		tempForce = pCluster->pBot->aimForce(targetBot->futurePosition(t) , pCluster->pBot->pBotType->max_force) * weight;
		if (PRINTAI) cout << "     > seeking ";
	}

	if (DRAWFORCE) pCluster->pBot->drawForce(tempForce);
	pCluster->pBot->total_force += tempForce;

	if (PRINTAI) cout << "bot[" << targetBot->universeID << "] distance: " << distance << "  futureTime:" << t << endl;
	activityState = updateActivity(); // check if the activity of the AI has changed
}

void seekBot::success() {
	if (flee) {
		//got away from the bot
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] got away from bot[" << targetBot->universeID << "] - well done" << endl;
		activityState = 0;
	} else {
		//got the bot
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] got bot[" << targetBot->universeID << "] - well done" << endl;
		activityState = 0;
	}
}

void seekBot::failure() {

	if (flee) {
		// was got by the bot
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] FAILED to get away bot[" << targetBot->universeID << "] - for shame" << endl;
		removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	} else {
		//didnt get the bot
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] FAILED to get bot[" << targetBot->universeID << "] - for shame" << endl;
		removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	}
}

int seekBot::updateActivity() {
	if (flee) {
		if (distance < 0.1) return 2; //target got the bot
		else if (distance > failureDistance) return 1; //got away from the bot
		else return 0; //it isnt too far or too close, keep on doing your thing
	} else {
		if (distance < 0.1) return 1; //the bot is close to the target. we have been successful
		else if (distance > failureDistance) return 2; //it is too far away from the target. give up
		else return 0; //it isnt too far or too close, keep on doing your thing
	}
}

void seekBot::calcDistance() {
	distance = (targetBot->position - pCluster->pBot->position).length();
}
void seekBot::drawFailDist() {
	colourList[2].Use();
	pCluster->pBot->drawCircle(failureDistance);
}

//*********************************************************************************
//seekPoint methods

void seekPoint::action() {

	calcDistance(); //recalculate how far from the target we are

	//drawFailDist();
	Vector tempForce;

	if (flee) {
		tempForce = -1 * (pCluster->pBot->aimForce(target , pCluster->pBot->pBotType->max_force) * weight);
		if (PRINTAI) cout << "     > fleeing ";
	} else {
		tempForce = pCluster->pBot->aimForce(target , pCluster->pBot->pBotType->max_force) * weight;
		if (PRINTAI) cout << "     > seeking ";
	}

	if (DRAWFORCE) pCluster->pBot->drawForce(tempForce);
	pCluster->pBot->total_force += tempForce;

	if (PRINTAI) cout << "point " << target << "   distance: " << distance << endl;
	activityState = updateActivity(); // check if the activity of the AI has changed
}

void seekPoint::success() {
	if (flee) {
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] got away from point " << target << " - well done" << endl;
		activityState = 0;
		//removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	} else {
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] got point " << target << " - well done" << endl;
		activityState = 0;
		//removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	}


}

void seekPoint::failure() {
	if (flee) {
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] FAILED to get away from point " << target << " - for shame" << endl;
		removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	} else {
		if (PRINTAI) cout << "Bot["<< pCluster->pBot->universeID <<"] FAILED to get point " << target << " - for shame" << endl;
		removeAI(pCluster, Cluster_Iter); //get rid of this AI module
	}

}

int seekPoint::updateActivity() {
	if (flee) {
		if (distance < 0.1) return 2; //point got the bot - not very likely, but hey...
		else if (distance > failureDistance) return 1; //got away from the Point
		else return 0; //it isnt too far or too close, keep on doing your thing
	} else {
		if (distance < 0.1) return 1; //the bot is close to the target. we have been successful
		else if (distance > failureDistance) return 2; //it is too far away from the target. give up
		else return 0; //it isnt too far or too close, keep on doing your thing
	}
}

void seekPoint::calcDistance() {
	distance = (target - pCluster->pBot->position).length();
}

void seekPoint::drawFailDist() {
	colourList[2].Use();
	pCluster->pBot->drawCircle(failureDistance);
}

//*********************************************************************************
//seperation methods

void seperation::action() {

	Vector seperationForce(0,0,0), tempVec;
	botGrp* tempGrp = NULL;
	for (int i=0; i < pCluster->pBot->pTheUniverse->numBots; i++) {
		//step through every bot in the universe
		if (pCluster->pBot->inNHood(&(pCluster->pBot->pTheUniverse->botList[i]), tempGrp)) {
			//the bot is within the neighbourhood and is in any group
			tempVec = seperation_force(&(pCluster->pBot->pTheUniverse->botList[i]));
			seperationForce += tempVec;
			if (PRINTAI) cout << "       > Bot[" << i << "] in NHood   Force:" << tempVec << endl;
		}

	}

	seperationForce = seperationForce * weight;

	//pCluster->pBot->drawCircle(pCluster->pBot->pBotType->NHoodRadius);
	if (DRAWFORCE) pCluster->pBot->drawForce(seperationForce);
	if (PRINTAI) cout << "     > Total Seperation Force: " << seperationForce << endl;
	pCluster->pBot->total_force += seperationForce;
}

void seperation::success() {

}

void seperation::failure() {

}

int seperation::updateActivity() {
	return 0;
}

Vector seperation::seperation_force(bot *pNearBot) {
	Vector tempVec = (pCluster->pBot->position - pNearBot->position);
	if (tempVec.length()!=0) tempVec.normalize();

	if (pCluster->pBot->position != pNearBot->position)
		tempVec = tempVec * 1 / (pCluster->pBot->position - pNearBot->position).length() ;

	tempVec = tempVec * pCluster->pBot->pBotType->max_force;

	if (DRAWFORCE) pCluster->pBot->drawForce(tempVec);

	return tempVec;
}

//*********************************************************************************
//cohesion methods

void cohesion::action() {

	int neighboursCount = 0;
	Vector cohesionForce(0,0,0);
	Vector cohesionCenter(0,0,0);

	botGrp* tempGrp = pCluster->pBot->pBotGrp;
	for (int i=0; i < pCluster->pBot->pTheUniverse->numBots; i++) {
		//step through every bot in the universe
		if (pCluster->pBot->inNHood(&(pCluster->pBot->pTheUniverse->botList[i]), tempGrp)) {
			//the bot is within the neighbourhood and is in any group
			neighboursCount++;

			cohesionCenter += pCluster->pBot->pTheUniverse->botList[i].position;
			if (PRINTAI) cout << "       > Bot[" << i << "] in NHood   Pos:" << pCluster->pBot->pTheUniverse->botList[i].position << endl;
		}

	}

	if (neighboursCount!=0) {
		cohesionCenter = cohesionCenter/neighboursCount; // calc average center of neighbourhood

		cohesionForce = pCluster->pBot->aimForce(cohesionCenter,1);
		cohesionForce = cohesionForce * weight;

		//pCluster->pBot->drawCircle(pCluster->pBot->pBotType->NHoodRadius);
		if (DRAWFORCE) pCluster->pBot->drawForce(cohesionForce);
		if (PRINTAI) cout << "     > Total Cohesion Force: " << cohesionForce << endl;

		pCluster->pBot->total_force += cohesionForce;
	}

}

void cohesion::success() {

}

void cohesion::failure() {

}

int cohesion::updateActivity() {
	return 0;
}


//*********************************************************************************
//alignment methods
void alignment::action() {

	int neighboursCount = 0;
	Vector alignmentForce(0,0,0);
	Vector alignmentVelocity(0,0,0);

	botGrp* tempGrp = pCluster->pBot->pBotGrp;
	for (int i=0; i < pCluster->pBot->pTheUniverse->numBots; i++) {
		//step through every bot in the universe
		if (pCluster->pBot->inNHood(&(pCluster->pBot->pTheUniverse->botList[i]), tempGrp)) {
			//the bot is within the neighbourhood and is in any group
			neighboursCount++;

			alignmentVelocity += pCluster->pBot->pTheUniverse->botList[i].velocity;
			if (PRINTAI) cout << "       > Bot[" << i << "] in NHood   velocity:" << pCluster->pBot->pTheUniverse->botList[i].velocity << endl;
		}

	}
	//cout << "aVelocity " << alignmentVelocity << endl;
	if (neighboursCount!=0) {
		alignmentVelocity = alignmentVelocity/neighboursCount; // calc average velocity of neighbourhood
		alignmentForce = alignmentVelocity - pCluster->pBot->velocity; //calc the force rather than the desired velocity

		if (alignmentForce.length()!=0) alignmentForce.normalize();

		alignmentForce = alignmentForce * weight;

		//pCluster->pBot->drawCircle(pCluster->pBot->pBotType->NHoodRadius);
		if (DRAWFORCE) pCluster->pBot->drawForce(alignmentForce);
		if (PRINTAI) cout << "     > Total Alignment Force: " << alignmentForce << endl;

		pCluster->pBot->total_force += alignmentForce;
	}


}

void alignment::success() {

}

void alignment::failure() {

}

int alignment::updateActivity() {
	return 0;
}

//*********************************************************************************
//followPath methods

void followPath::action() {

	if (!thePath->pointList.empty()) {
		//the path isnt empty
			Colour tempCol(1,0.9,0.5);
			tempCol.Use();
			thePath->draw();

		Vector pointTarget = thePath->pointList[currPointID];
		Vector tempForce = pCluster->pBot->aimForce(pointTarget , pCluster->pBot->pBotType->max_force) * weight;
		pCluster->pBot->total_force += tempForce;

		if ((pCluster->pBot->position - pointTarget).length() < thePath->radius) {
			//its near the point, seek the next one
			if (dirInvert==0) currPointID++; else currPointID--;
		}

		activityState = updateActivity(); // check if the activity of the AI has changed
	}
}

void followPath::success() {
	if (dirInvert==0) dirInvert = 1; else dirInvert=0;
	activityState=0;//make it active
}

void followPath::failure() {

}

int followPath::updateActivity() {
	if (!dirInvert) {
		if (currPointID >= thePath->pointList.size()-1) {
			//it reached the last point
			return 1; //it was a success
		}
	} else {
		if (currPointID <= 0) {
			//it reached the last point
			return 1; //it was a success
		}
	}
	return activityState;
}

