#ifndef ASTAR_H_INCLUDED
#define ASTAR_H_INCLUDED


#include <cstdlib>
#include <vector>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"

#include "ai.h"
#include "botclass.h"
#include "path.h"
#include "map.h"

using namespace std;
using namespace GraphicsLib;

extern Colour colourList[6];

class bot;
class path;

class AIthought;
class shortestRoute;
class AstarNode;

typedef vector <AstarNode*>::iterator AstarList_Iter;


class AstarNode {
    public:
    	int x,y; // x/y coords on the map

	float value; //the map value at the coordinates
	float f; // sum of g+h - lists are indexed by this value
	float g; //sum of costs to get to this node
	float h; //heuristic - how far node is from destination

	bool list; // 0:open 1:closed

	int parentX;
	int parentY;

	//overloaded comparison operators - compare just the f value for sorting
	bool AstarNode::operator<(const AstarNode& rhs) { return (f < rhs.f); }
	bool AstarNode::operator>(const AstarNode& rhs) { return (f > rhs.f); }
	bool AstarNode::operator<=(const AstarNode& rhs) { return (f <= rhs.f); }
	bool AstarNode::operator>=(const AstarNode& rhs) { return (f >= rhs.f); }
	bool AstarNode::operator==(const AstarNode& rhs) { return (f == rhs.f); }
	bool AstarNode::operator!=(const AstarNode& rhs) { return (f != rhs.f); }
};

#endif


