
#include "botclass.h"

using namespace std;
using namespace GraphicsLib;


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//bot methods
bot::bot() {
//null all the variables that need to be nulled

 	pBotGrp = NULL; //not set - so that if a tempBot is created it can be destroyed without fucking with the group

	position.null();
	velocity.null();
	AIbrain = NULL;

	cout << "..........new Bot.........." << endl;

}

bot::~bot()  {


}

void bot::doAction() {

	total_force.null();
	//cout << position << " :" << endl;
	//cout << " > AI calculations:\n";
	AIbrain->action(); //do all the ai calculations to figure out the force that is going to push the bot around

	//cout << "totalForce: " << total_force << endl;
	applyForce(total_force); //apply the newly generated force to the bot's velocity
	//cout << " > Apply Force: " << total_force << endl;

	moveBot(pTheUniverse->masterClock.interval);

	pBotGrp->grpColour.Use();
	drawBot();
	//drawCircle(pBotType->radius + pBotType->comfort_Dist);

	colourList[2].Use();
	drawVector(forward_orientation*pBotType->max_speed);

	colourList[3].Use();
	drawVector(velocity);
}

void bot::applyForce(Vector force_in)
{
	//limit the force to the max force
	Vector tempVector = truncateVec(force_in, pBotType->max_force);
	//cout << "Applying force:" << force_in << "  trunced to:" << tempVector;
	tempVector = tempVector / pBotType->mass; //get acceleration vector by dividing by its mass

	//change the velocity by applying the accelVector and limiting to max_speed
	velocity = truncateVec(tempVector + velocity, pBotType->max_speed);

	//cout << "  accelVector:" << tempVector << "  new Velocity:" << velocity << endl;
}

void bot::moveBot(float timeInterval)
{
	//timeInterval is how much of a second passes between the call of move
	position += (velocity * timeInterval); //add the velocity to the position to find the next position...
	calcOrientation();
}

bool bot::inNHood(Vector testPoint, float NHdistance, float NHangle) {

    if ((testPoint - position).length() <= NHdistance) {
	//its inside the neighbourhood
	//if (forward_orientation.AngleBetween((testPoint - position)) <= NHangle) {
		//its within the angle
		return true;
	//} else return false;
    } else return false;

}

bool bot::inNHood(bot* pWhatBot, botGrp* pWhatGrp) {
//checking to see if whatBot is within the neighbourhood and is in whatGroup
// set pWhatGrp to null to check against every group
	if (pWhatBot->universeID!= universeID) {
		if (pWhatGrp!= NULL) {
			if (pWhatBot->pBotGrp == pWhatGrp) {
				//its in the group
				return inNHood(pWhatBot->position, pBotType->NHoodRadius, pBotType->NHoodAngle);
			} else return false; //its not in the group
		} else return inNHood(pWhatBot->position, pBotType->NHoodRadius, pBotType->NHoodAngle); //not checking against groups
	} else return false; //its the same bot
}

//************************ bot drawing funcs ****************************

void bot::drawBot() {
  Vector GLposition = pTheUniverse->globalMap.convToGL(position);
  float GLradius = pTheUniverse->globalMap.convToGL(pBotType->radius);
	//cout << "bot[" << universeID << "] GLposition: " << GLposition << endl;
  glPushMatrix();
	glTranslatef(GLposition.x,GLposition.y,0);
	glutWireSphere(GLradius, 10, 2);
  glPopMatrix();
}

void bot::drawCircle(float radius) {
	Vector GLposition = pTheUniverse->globalMap.convToGL(position);
	float GLradius = pTheUniverse->globalMap.convToGL(radius);

	int num_lines = 10;
	float angle;

	glPushMatrix();
		glTranslatef(GLposition.x,GLposition.y,0);
 		glBegin(GL_LINE_LOOP);
    			for(int i =0;i<num_lines;i++){
      				angle = i*2*PI/num_lines;
      				glVertex2f(cos(angle)*GLradius,sin(angle)*GLradius);
			}
  		glEnd();
	glPopMatrix();
}

void bot::drawVector(Vector theVector)
{
  glPushMatrix();
	Vector tempHead = pTheUniverse->globalMap.convToGL(position);
	Vector tempTail = pTheUniverse->globalMap.convToGL(position + theVector);

	glBegin(GL_LINES);
		glVertex3f(tempHead.x, tempHead.y, 0.0);
		glVertex3f(tempTail.x, tempTail.y, 0.0);
	glEnd();
  glPopMatrix();
}

void bot::drawForce(Vector theForce)
{
	colourList[5].Use();
	drawVector((theForce/pBotType->max_force)*pBotType->max_speed);
}

//********************************************************************************************
/*

// an old collision response method. not imlemented, but the code has been written

void bot::BodyCollisionResponse(bot *testBot) {


>>>>>>>>>>from http://nehe.gamedev.net/data/lessons/lesson.asp?lesson=30
X_Axis = (center2 - center1);
Unify X_Axis, X_Axis.unit();

b) Find Projections

U1x= X_Axis * (X_Axis dot U1)
U1y= U1 - U1x
U2x =-X_Axis * (-X_Axis dot U2)
U2y =U2 - U2x

c) Find New Velocities

(U1x * M1)+(U2x*M2)-(U1x-U2x)*M2
V1x= --------------------------------
M1+M2
(U1x * M1)+(U2x*M2)-(U2x-U1x)*M1
V2x= --------------------------------
M1+M2

In our application we set the M1=M2=1, so the equations get even simpler.

d) Find The Final Velocities

V1y=U1y
V2y=U2y
V1=V1x+V1y
V2=V2x+V2y


// find the vector of the axis that joins the bot to the test body
Vector x_axis = position-testBot->position;
x_axis.normalize();


//find the vectors of the velocity projected onto the axis that joins the 2 bodies
Vector U1x = x_axis * (x_axis.dot(velocity));
Vector U1y = velocity - U1x;

Vector U2x = (x_axis*-1) * ((x_axis*-1).dot(testBot->velocity));
Vector U2y = testBot->velocity - U2x;

//1st bot's velocity components
Vector V1x = ( (U1x * pBotType->mass)+(U2x * testBot->pBotType->mass)-((U1x-U2x)*testBot->pBotType->mass) ) / ( pBotType->mass+testBot->pBotType->mass );
Vector V1y = U1y;

//2nd bot's velocity components
Vector V2x = ( (U1x * pBotType->mass)+(U2x * testBot->pBotType->mass)-((U2x-U1x)*pBotType->mass) ) / ( pBotType->mass+testBot->pBotType->mass );
Vector V2y = U2y;

velocity = V1x+V1y;
testBot->velocity = V2x + V2y;

//Thankyou Nehe. you make it easy
}


Vector bot::aiFunc_SCA(float SepWeight, float CohWeight, float AliWeight) {

	int neighboursCount = 0;
	Vector seperationForce(0,0,0), cohesionForce(0,0,0), alignmentForce(0,0,0);

	Vector cohesionCenter(0,0,0);
	Vector alignmentVelocity(0,0,0);

	for (int i=0; i<pBotGrp->numBots; i++) {
		// step through every bot in the group
		if (grpID != i) {
			//if its not the current bot
			if (inNHood(pBotGrp->botList[i].position, pBotType->NHoodDistance, pBotType->NHoodAngle)) {
				cout << "bot:" << i << " in Nhood of bot:" << grpID << endl;
				//if is within the bot's neighbourhood
				neighboursCount++;

				//keep away from nearby bots
				seperationForce = seperationForce + aiFunc_Seperation(&pBotGrp->botList[i]);

				//stick near to center of neighbourhood (only if in same group TODO)
				cohesionCenter += pBotGrp->botList[i].position;

				//stick to the same direction as the neighbourhood (only if in same group TODO)
				alignmentVelocity += pBotGrp->botList[i].velocity;
			}
		}

	}
	cout << "NH count: " << neighboursCount << endl;

	if (neighboursCount!=0) {
		seperationForce.normalize();

		cohesionCenter = cohesionCenter/neighboursCount; // calc average center of neighbourhood
		cohesionForce = aimForce(cohesionCenter,1);

		alignmentVelocity = alignmentVelocity/neighboursCount; // calc average velocity of neighbourhood
		alignmentForce = alignmentVelocity - velocity; //calc the force rather than the desired velocity
		alignmentForce.normalize();

		return ((seperationForce*SepWeight) + (cohesionForce*CohWeight) + (alignmentForce*AliWeight));
	} else {
		return cohesionForce; // this is a zero force;
	}
}
*/
