//botclass.h
#ifndef BOTCLASS_H_INCLUDED
#define BOTCLASS_H_INCLUDED

#include <vector>
#include <cstdlib>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"

#include "universeclass.h"
#include "vehicle.h"
#include "botgrpclass.h"
#include "ai.h"

using namespace std;
using namespace GraphicsLib;

extern Colour colourList[6];

class universe;
class botGrp;
class bot;
class botType;
class neighbourhood;
class AIthought;
class AIcluster;

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//bot class
class bot : public vehicle {

    public:
	int universeID;
	universe *pTheUniverse;

	botType *pBotType; //what class of vehicle it is

	botGrp *pBotGrp; //the group the bot is in
	int grpID; //the index for in the list

	AIcluster* AIbrain; //a cluster of thoughts with a mentality

	bot();
	~bot();

	AIcluster* addAIcluster();
	void doAction();

	void moveBot(float timeInterval);
	void applyForce(Vector force_in);

	bool inNHood(Vector testPoint, float NHdistance, float NHangle);
	bool inNHood(bot* pWhatBot, botGrp* pWhatGrp);


	void drawBot();
	void drawCircle(float radius);
	void drawVector(Vector theVector);
	void drawForce(Vector theForce);
};

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//botType class
class botType{

    public:
	int universeID;
	universe *pTheUniverse;

	float mass;
	float radius;
	float comfort_Dist; //how far from the radius the mind people being.
	float max_speed;
	float max_force;

	float NHoodRadius; // neighbourhood info
	float NHoodAngle;
};

#endif
