// map functions and definitions by lHufford - oct 2004

#ifndef MAP_H_INCLUDED //only declare if not already declared
#define MAP_H_INCLUDED

#include <cstdlib>
#include <vector>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"

//my libraries
//#include "image.h"
#include "universeclass.h"


using namespace std;
using namespace GraphicsLib;

// all the classes that it will see in this file
class dataMap;
class universe;


/*!
\file map.h
\brief map variable defintions and function defintions
\author Laurie Hufford
\version 0.2
\date 29/10/04
\bug
\todo
\warning
*/

/*!
\enum mapDataType
\brief the types of map data that can be used
*/

enum mapDataType {
	HEIGHT, /*!height info - value in metres*/
	MAX_SPEED, /*! the max spemapFileImg.heighted that can be travelled over a map - value in m/s */
	FEAR_DESIRE, /*! the repel/attract value of the map - value between -1 and 1 */
	VISIBILITY, /*! Whether the map is known about - value 1 or 0 */
	INFLUENCE /*! where a group is putting pressure */
};


class dataMap {
  public:
 	int universeID;
	universe *pTheUniverse;

   	int dataHeight; // number of data elements in y
	int dataWidth; //number of data elements in x

	float dataResHeight; //number of globalUnits per dataElement for width and height
	float dataResWidth;

	float **valueArray; //2dim array of values for each map

	float scaleFactor; // multiply value[][] by this to get the actual data - eg turn image data into useable values


	mapDataType dataType; // the type of map - so that functions know how to deal with its data


	//methods...
	dataMap();
	~dataMap();

	void assignMapFile(char* mapFileName);
	void drawMap();
	
	void setValue( double value, int xCoord, int yCoord);
	float getValue(int xCoord, int yCoord){ return valueArray[xCoord][yCoord]; }

	Vector convMAPcoordtoGU (int xCoord, int yCoord);

	Vector convGUtoMAPcoord (float GUxCoord, float GUyCoord);

	Vector nearestMAPcoord(float GUxCoord, float GUyCoord);
};

#endif
