#include "routeOGL.h"
using namespace std;
using namespace GraphicsLib;

/// do custom app initialisation here
void OnInit() {

	//add a single type to the universe
	theUniverse.addType(20, 2, 1, 15, 15, 20, 360); //mass, radius, comfortDist, maxspeed, maxforce, nhood radius, nhood angle




if (mode == 8) {
		//Generate a map from the file
		theUniverse.addMap(theMap);

		Vector routeFindingStart(10,20,0);
		Vector routeFindingEnd(200,260,0);

		//add the first group with the specified colour and starting position
		Colour groupColour(0.8,0,0);
		theUniverse.addGrp(routeFindingStart, groupColour);

		 // create a single bot, placing it in group 0 and giving it type 0
		theUniverse.addBot(&theUniverse.botGrpList[0], &theUniverse.botTypeList[0]);

			//give the first bot in group 0 a shortest route between the specified locations
		theUniverse.botGrpList[0].pBotList[0]->AIbrain->addAI_shortestRoute(routeFindingStart, routeFindingEnd, &theUniverse.mapDataList[0], 50, 0.5, 1, 0);

} else {
	//add the first group with the specified colour and starting position
	Colour groupColour(0.8,0,0);
	Vector GroupStartPos(0,0,0);
	theUniverse.addGrp(GroupStartPos, groupColour);

	//add the second group with the colour and start position
	groupColour.set(0.8,1,0);
	GroupStartPos.set(150,300,0);
	theUniverse.addGrp(GroupStartPos, groupColour); // add a single group to the universe

	//the initial levels of seperation, cohesion and alignment
	float sepWeight = tempSeperation;
	float cohWeight = tempCohesion;
	float aliWeight = tempAlignment;
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	int MakeNumBots = 65; //how many bots are to be added to group 0
	 // create bots, placing them in group 0 and giving them type 0
	for (int i=0; i<MakeNumBots; i++) {
		theUniverse.addBot(&theUniverse.botGrpList[0], &theUniverse.botTypeList[0]);
	}
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	Vector tempVec(200,200,0); //group 0's seek point
	//step through every bot in group 0 adding cohesion, separation and alignment thoughts, and a seekPoint thought

	for (int i=0; i<theUniverse.botGrpList[0].numBots; i++) {
		theUniverse.botGrpList[0].pBotList[i]->AIbrain->addAI_Seperation(sepWeight, 0, 0);
		theUniverse.botGrpList[0].pBotList[i]->AIbrain->addAI_Cohesion(cohWeight, 0, 0);
		theUniverse.botGrpList[0].pBotList[i]->AIbrain->addAI_Alignment(aliWeight, 0, 0);
		theUniverse.botGrpList[0].pBotList[i]->AIbrain->addAI_SeekPoint(tempVec, 500.0, 0, 0.5, 1, 0);
		//theUniverse.botGrpList[0].pBotList[i]->AIbrain->printAIlist();
	}

	//*************************************************************************

	MakeNumBots = 50; //how many bots are to be added to group 1
	// create bots, placing them in group 1 and giving them type 0
	for (int i=0; i<MakeNumBots; i++) {
		theUniverse.addBot(&theUniverse.botGrpList[1], &theUniverse.botTypeList[0]); // make this many bots
	}
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	tempVec.set(100,100,0); //group 1's seek point
	for (int i=0; i<theUniverse.botGrpList[1].numBots; i++) {
		//step through every bot in group 1 adding cohesion, separation and alignment thoughts, and a seekPoint thought
		theUniverse.botGrpList[1].pBotList[i]->AIbrain->addAI_Seperation(sepWeight, 0, 0);
		theUniverse.botGrpList[1].pBotList[i]->AIbrain->addAI_Cohesion(cohWeight, 0, 0);
		theUniverse.botGrpList[1].pBotList[i]->AIbrain->addAI_Alignment(aliWeight, 0, 0);
		theUniverse.botGrpList[1].pBotList[i]->AIbrain->addAI_SeekPoint(tempVec, 500.0, 0, 0.5, 1, 0);
		//theUniverse.botGrpList[1].pBotList[i]->AIbrain->printAIlist();
	}

	//*************************************************************************
	//theUniverse.printGrpList();
}

	//for each group place the bots around the group start pos
	for (int i=0; i<theUniverse.numBotGrps; i++) {
		theUniverse.botGrpList[i].placeBots(theUniverse.botGrpList[i].startPos);
	}


	theUniverse.masterClock.start(); //start the universe clock
}


// used to render the contents of the window
void OnDraw() {
	glClear(GL_COLOR_BUFFER_BIT);

	//cout << "fps: " << theUniverse.masterClock.fps() << endl;

	theUniverse.doAction(); //do a step in the life of the universe

	theUniverse.masterClock.update(); //update the universe's clock every tick

	glutSwapBuffers();
}
