#include "screen.h"

using namespace std;
using namespace GraphicsLib;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

screen::screen() {

};

screen::screen(float width, float height) {
	size.x = width;
	size.y = height;
	aspectRatio = width/height;
}

Vector screen::convToGL(Vector GUunits) {
	Vector tempVec(((GUunits.x /size.x) *2 )-1, ((GUunits.y /size.y) *2 )-1);
	return tempVec;
}


void screen::GUToGLvertex(float mapCoordX, float mapCoordY) {
	Vector mapVec(mapCoordX, mapCoordY, 0);
	mapVec = convToGL(mapVec);
	glVertex3f(mapVec.x, mapVec.y, 0.0);
}

float screen::convToGL(float GUunit) {
	//average the size.x and size.y
	return ((GUunit / ((size.x+size.y)/2)) *2 );
}

Vector screen::convToGU(int PixelCoordX, int PixelCoordY) {
	Vector tempVector((size.x/(WIN_HEIGHT*aspectRatio))*PixelCoordX,(size.y/WIN_HEIGHT)*(WIN_HEIGHT-PixelCoordY), 0);
	return tempVector;
}

void screen::draw() {
	Vector temp;
		glBegin(GL_LINE_LOOP);
			temp.set(0,0,0); temp = convToGL(temp);
			  glVertex2f(temp.x, temp.y);
			temp.set(size.x,0,0);  temp = convToGL(temp);
			  glVertex2f(temp.x, temp.y);
			temp.set(size.x,size.y,0);  temp = convToGL(temp);
			  glVertex2f(temp.x, temp.y);
			temp.set(0,size.y,0);  temp = convToGL(temp);
			  glVertex2f(temp.x, temp.y);
		glEnd();
}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
visibleArea::visibleArea(float width, float height, float bottomLeftX, float bottomLeftY)
	: screen(width,height) {

	size.x = width;
	size.y = height;

	aspectRatio = width/height;

	bottomLeft.x = bottomLeftX;
	bottomLeft.y = bottomLeftY;

}

void visibleArea::set(float width, float height, float bottomLeftX, float bottomLeftY) {
	size.x = width;
	size.y = height;

	aspectRatio = width/height;

	bottomLeft.x = bottomLeftX;
	bottomLeft.y = bottomLeftY;
}

Vector visibleArea::convToGL(Vector GUunits) {
	Vector tempVec((((GUunits.x-bottomLeft.x) /size.x) *2 )-1, (((GUunits.y-bottomLeft.y) /size.y) *2 )-1);
	return tempVec;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
