#ifdef __USINGWINDOWS__
    #include <windows.h>
#else
    #include <unistd.h>
#endif

#include "timer.h"
#include <sys/time.h>
#include <time.h>


Timer::Timer(bool active_in)
{
	active = active_in;
	if (active) start();

}

double Timer::getTimeOfDay() {
	timeval timVal; //weird unix time value that stores secs and microsecs
	gettimeofday(&timVal, NULL);
	return timVal.tv_sec + (timVal.tv_usec/1000000.0);
}

void Timer::start() {
	// start a fresh count
	prevTime = getTimeOfDay();
	duration = 0;
	interval = 0;
	active = true;
}

void Timer::pause() {
	//call when clock is active to freeze time, call when inactive to unfreeze
	if (active) {
		active = false;
	} else {
		active = true;
		prevTime = getTimeOfDay();
	}
}

void Timer::stop() {
	//stop and reset clock
	active = false;
	prevTime = getTimeOfDay();
	duration = 0;
	interval = 0;
}


void Timer::update() {
	// update the values in the timer
  if(active) {

	double currTime = getTimeOfDay();

	interval = currTime - prevTime;

	duration += interval;

	prevTime = currTime;
  }
}
