//universeclass.h
#ifndef UNIVERSECLASS_H_INCLUDED
#define UNIVERSECLASS_H_INCLUDED

#include <vector>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"

//my libraries
#include "vehicle.h"
#include "botclass.h"
#include "botgrpclass.h"
#include "screen.h"
#include "map.h"
#include "timer.h"

using namespace std;
using namespace GraphicsLib;

// all the classes that it will see in this file
class universe;
class bot;
class botGrp;
class botType;
class AIcluster;
class screen;
class dataMap;
class Timer;


Vector truncateVec(Vector vecA, float max);

class universe {

   public:
	vector <bot> botList; //list of every bot in the universe
	int numBots;

	vector <botGrp> botGrpList;
	int numBotGrps;

	vector <botType> botTypeList; //list of all the types of bots in the universe
	int numBotTypes;

	screen globalMap;

	vector <dataMap> mapDataList; //list of all the map data that is in the universe
	int numMaps;

	Timer masterClock;

	Vector mousePos; // the position in screenPixels of the cursor

     //methods
	universe(float universeWidth_in, float universeHeight_in); //make a new universe to the specified dimensions
	~universe();

	void doAction();

	bot* addBot(botGrp* pWhatGrp, botType* pWhatType);
	void removeBot(int whatID);

	botGrp* addGrp(Vector startPos_in, Colour grpColour_in);
	botType* addType(float mass_in, float radius_in, float comfort_in, float maxspeed_in, float maxforce_in, float NHoodDist_in, float NHoodAngle_in);

	dataMap* addMap(char* dataMapFile);
	//void removeMap(int whatID);

	void updateBotPointers();
	void updateGrpPointers();

	void printGrpList();

};


#endif
