#include "vehicle.h"

using namespace std;
using namespace GraphicsLib;

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//vehicle methods:

//sets the attributes of the vehicle
void vehicle::set(Vector forward_in, Vector velocity_in, Vector position_in) {

	forward_orientation = forward_in;
	velocity = velocity_in;
	position = position_in;

	cout << "Setting Vehicle: Pos:" << position << " velocity: " << velocity << " forward:" << forward_orientation << endl;
	calcOrientation();

}
//*******************************************************

//calculate the vehicles new orientation vectors based on its current velocity
void vehicle::calcOrientation()
{
	if (velocity.length()>0) {
		forward_orientation = velocity;
	}
	forward_orientation.normalize();

	Vector tempVector(0,0,1); //up vector
	side_orientation = forward_orientation.cross(tempVector);
}
//***************************************************

//where the vehicle will be in the t future
Vector vehicle::futurePosition(float t=0)
{
// t is the number of frames into the future we want to predict
// with no t value it returns the current position
	Vector tempVector;
	tempVector = position + (velocity * t);

	return tempVector;
}
//********************************************************

// return a force of the magnitude that aims at a point
Vector vehicle::aimForce(Vector target, float magnitude)
{
	Vector tempVec = target - position;
	if (tempVec.length()!=0) tempVec.normalize();

	return (tempVec*magnitude);
}
//***************************************************



//methods not fully implemented

bool vehicle::collided(float vehicle_radius, Vector test_pos ,float test_radius) {
	//true if collision is occuring
	float distance = (position - test_pos).length();
	if (distance <= (vehicle_radius+test_radius)) return true; else return false;
}

bool vehicle::screenEdgeCollision(float vehicle_radius, float ScreenWidth, float ScreenHeight) {
	//true if collision is occuring
	if (position.x <= vehicle_radius) {
		return true;
	} else if ((ScreenWidth - position.x) <= vehicle_radius) {
		return true;
	} else if (position.y <= vehicle_radius) {
		return true;
	} else if ((ScreenHeight - position.y) <= vehicle_radius) {
		return true;
	} else return false;
}


Vector vehicle::collisionPoint(float vehicle_radius, Vector test_pos) {
	//where the collision occured in 3d space
	Vector tempVec = position-test_pos;
	tempVec.normalize();
	tempVec *= vehicle_radius;

	return (position + tempVec);
}


	// movement force methods
Vector vehicle::turnLeftForce(float magnitude)
{
	return side_orientation*(-magnitude);
}
Vector vehicle::turnRightForce(float magnitude)
{
	return side_orientation*(magnitude);
}
Vector vehicle::forwardForce(float magnitude)
{
	return forward_orientation*(magnitude);
}
Vector vehicle::backwardForce(float magnitude)
{
	return forward_orientation*(-magnitude);
}

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/


//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



