#ifndef VEHICLE_H_INCLUDED
#define VEHICLE_H_INCLUDED

#include <vector>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "GraphicsLib.h"


using namespace std;
using namespace GraphicsLib;


// all the classes that it will see in this file
class vehicle;

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
//vehicle class
class vehicle {
   public:
	Vector velocity; //in m (or GUs to be more specific) per second
	Vector position;
	Vector forward_orientation;
	Vector side_orientation;
	Vector total_force;


	void set(Vector forward_in, Vector velocity_in, Vector position_in);
	void calcOrientation();
	Vector futurePosition(float t);

	Vector aimForce(Vector target, float magnitude);



	// not properly implemented methods
	bool collided(float vehicle_radius, Vector test_pos ,float test_radius);
	bool screenEdgeCollision(float vehicle_radius, float ScreenWidth, float ScreenHeight);
	Vector collisionPoint(float vehicle_radius, Vector test_pos);

	Vector turnLeftForce(float magnitude);
	Vector turnRightForce(float magnitude);
	Vector forwardForce(float magnitude);
	Vector backwardForce(float magnitude);
};

#endif
