//---------------------------------------------------------------------------------------
/// \brief	This is just a basic framework for glut apps to get you started.
///
//---------------------------------------------------------------------------------------

#include <iostream>
#include <GL/glut.h>
#include <math.h>

#include "GraphicsLib.h"

#include "universeclass.h"
#include "routeOGL.h"

using namespace std;
using namespace GraphicsLib;


	int WIN_HEIGHT = 800; //how tall the window is - the width is based on the MainMap Aspect Ratio - porbably needs to be changed

	Vector prevMousePos;
	bool mouseMove;

	Colour colourList[6] =	{
				Colour(0,0,0), //0 black
				Colour(1,1,1), //1 white
				Colour(1.0,0.1,0.1), //2 red
				Colour(0.1,0.1,1.0), //3 blue
				Colour(0.1,1.0,0.1), //4 green
				Colour(1.0, 1.0, 0.1) //5 yellow
				};
				
	universe theUniverse(300,300);  // the width and height in Global Units

	//userControl stuff
	char* theMap;
	int currentGrp = 0; //number keys select group
	int currentType = 0; //number keys select group
	float tempCohesion = 10, tempSeperation = 8, tempAlignment = 1; //inital cohesion separation and alignment values
	int mode = 0; //0=cohesion 1=seperation 2=alignment 3=mass 4=radius 5=maxforce 6=maxvelocity 7=neighbourhoodRadius 8=MapMode

	Vector MouseTarget; //where the mouse has clicked




void setWeight(float amount, string type) {
//set the weight of an AIthought
cout << "\nSetting Group[" << currentGrp << "] "<< type <<" weight to " << amount << endl;
AIthoughtList_Iter tempIter;
	for (int i=0; i < theUniverse.botGrpList[currentGrp].numBots; i++) {
		for (tempIter = theUniverse.botGrpList[currentGrp].pBotList[i]->AIbrain->AIthoughtList.begin(); tempIter != theUniverse.botGrpList[currentGrp].pBotList[i]->AIbrain->AIthoughtList.end(); ++tempIter) {
			if ((tempIter->second)->AIname == type ) {
				(tempIter->second)->weight = amount;
				break;
			}

		}
	}

}

void setGrpSeek(Vector setWhere) {
//set the position of a groups seekPoint thought
cout << "\nSetting Group[" << currentGrp << "] to seek " << setWhere << endl;
AIthoughtList_Iter tempIter;
seekPoint* tempSeekPoint;
	for (int i=0; i < theUniverse.botGrpList[currentGrp].numBots; i++) {
		for (tempIter = theUniverse.botGrpList[currentGrp].pBotList[i]->AIbrain->AIthoughtList.begin(); tempIter != theUniverse.botGrpList[currentGrp].pBotList[i]->AIbrain->AIthoughtList.end(); ++tempIter) {
			if ((tempIter->second)->AIname == "SEEKPOINT" ) {
				tempSeekPoint = dynamic_cast<seekPoint*>(tempIter->second);
				tempSeekPoint->target = setWhere;
				break;
			}

		}
	}

}

void setCurr(int whatNum) {
//choose the current group to control
	if (theUniverse.numBotGrps > whatNum) {
		cout << "\nGroup " << whatNum << " chosen - "<< theUniverse.botGrpList[whatNum].numBots << " bot(s) in this group\n   Click to choose a point to seek" << endl;
		currentGrp = whatNum;
	} else {
		cout << "\nGroup " << whatNum << " doesn't exist" << endl;
	}
}

/// delete any resources or dynamic data here....
void OnExit() {
}

/// used to handle changes in screen resolution
void OnResize(int w,int h) {
	glViewport(0,0,w,h);

}

/// used to handle mouse button presses and releases
void OnMouseButton(int button, int state,int x,int y) {
	bool Pressed = (state==GLUT_DOWN)? true : false;

	if(Pressed) {
	   switch(button) {
		case GLUT_LEFT_BUTTON:
			MouseTarget = theUniverse.globalMap.convToGU(x, y);
			setGrpSeek(MouseTarget);
			break;
		case GLUT_MIDDLE_BUTTON:
			break;
		case GLUT_RIGHT_BUTTON:
			break;
		default:
			break;
		}
	}
	else {
		switch(button) {
		case GLUT_LEFT_BUTTON:
			mouseMove = false;
			break;
		case GLUT_MIDDLE_BUTTON:
			break;
		case GLUT_RIGHT_BUTTON:
			break;
		default:
			break;
		}
	}
	glutPostRedisplay();
}

/// handles the movement of the mouse when a button is held
void OnMouseMove(int x,int y) {
	glutPostRedisplay();
}

/// handles the passive motion of the mouse
void OnMousePassive(int x,int y) {
	theUniverse.mousePos = theUniverse.globalMap.convToGU(x, y);
	//theUniverse.mousePos.y = (float)y;
	theUniverse.mousePos.z = 0;
	glutPostRedisplay();
}

/// handles a key press of the normals keys
void OnKeyPress(unsigned char key,int x,int y) {

  switch (key)
  {
  case 27:             /* ESC */
	 exit(0);
	 break;
  case '0' :
	setCurr(0);
  	break;
  case '1' :
  	setCurr(1);
  	break;
  case '2' :
  	setCurr(2);
  	break;
  case '3' :
  	setCurr(3);
  	break;
  case '4' :
  	setCurr(4);
  	break;
  case '5' :
  	setCurr(5);
  	break;
  case '6' :
  	setCurr(6);
  	break;
  case '7' :
  	setCurr(7);
  	break;
  case '8' :
  	setCurr(8);
  	break;
  case '9' :
  	setCurr(9);
  	break;

  case '+' :
  	if (mode==0) {
		tempCohesion +=0.1;
  		setWeight(tempCohesion, "COHESION");
	} else if (mode==1) {
		tempSeperation +=0.1;
  		setWeight(tempSeperation, "SEPERATION");
	} else if (mode==2) {
		tempAlignment +=0.1;
  		setWeight(tempAlignment, "ALIGNMENT");
	} else if (mode==3) {
		theUniverse.botTypeList[currentType].mass += 0.1;
		cout << "Type["<<currentType<<"] mass: "<< theUniverse.botTypeList[currentType].mass << endl;
	} else if (mode==4) {
		theUniverse.botTypeList[currentType].radius += 0.1;
		cout << "Type["<<currentType<<"] radius: "<< theUniverse.botTypeList[currentType].radius << endl;
	} else if (mode==5) {
		theUniverse.botTypeList[currentType].max_force += 0.1;
		cout << "Type["<<currentType<<"] maximum Force: "<< theUniverse.botTypeList[currentType].max_force << endl;
	} else if (mode==6) {
		theUniverse.botTypeList[currentType].max_speed += 0.1;
		cout << "Type["<<currentType<<"] maximum Velocity: "<< theUniverse.botTypeList[currentType].max_speed << endl;
	} else if (mode==7) {
		theUniverse.botTypeList[currentType].NHoodRadius += 0.1;
		cout << "Type["<<currentType<<"] neighbourhood radius: "<< theUniverse.botTypeList[currentType].NHoodRadius << endl;
	}
  	break;
  case '-' :
  	if (mode==0) {
		tempCohesion -=0.1;
  		setWeight(tempCohesion, "COHESION");
	} else if (mode==1) {
		tempSeperation -=0.1;
  		setWeight(tempSeperation, "SEPERATION");
	} else if (mode==2) {
		tempAlignment -=0.1;
  		setWeight(tempAlignment, "ALIGNMENT");
	} else if (mode==3) {
		theUniverse.botTypeList[currentType].mass -= 0.1;
		cout << "Type["<<currentType<<"] mass: "<< theUniverse.botTypeList[currentType].mass << endl;
	} else if (mode==4) {
		theUniverse.botTypeList[currentType].radius -= 0.1;
		cout << "Type["<<currentType<<"] radius: "<< theUniverse.botTypeList[currentType].radius << endl;
	} else if (mode==5) {
		theUniverse.botTypeList[currentType].max_force -= 0.1;
		cout << "Type["<<currentType<<"] maximum Force: "<< theUniverse.botTypeList[currentType].max_force << endl;
	} else if (mode==6) {
		theUniverse.botTypeList[currentType].max_speed -= 0.1;
		cout << "Type["<<currentType<<"] maximum Velocity: "<< theUniverse.botTypeList[currentType].max_speed << endl;
	} else if (mode==7) {
		theUniverse.botTypeList[currentType].NHoodRadius -= 0.1;
		cout << "Type["<<currentType<<"] neighbourhood radius: "<< theUniverse.botTypeList[currentType].NHoodRadius << endl;
	}
  	break;


  case 'c' :
  	if (mode!=8) {
		mode = 0;
		cout << "** COHESION mode - use '+' to increase weight, '-' to decrease weight **" << endl;
  	}
	break;
  case 'a' :
  if (mode!=8) {
  	mode = 2;
	cout << "** ALIGNMENT mode - use '+' to increase weight, '-' to decrease weight **" << endl;
  	}
	break;
  case 's' :
 	 if (mode!=8) {
   	mode = 1;
	cout << "** SEPERATION mode - use '+' to increase weight, '-' to decrease weight **" << endl;
	}
	 break;
  case 'm' :
  if (mode!=8) {
  	cout << "** MASS mode - use '+' to increase value, '-' to decrease value **" << endl;
  	mode = 3;
  }
	break;
  case 'n' :
  if (mode!=8) {
  	cout << "** NEIGHBOURHOOD RADIUS mode - use '+' to increase value, '-' to decrease value **" << endl;
  	mode = 7;
	}
	break;

  case 'r' :
  if (mode!=8) {
  	cout << "** RADIUS mode - use '+' to increase value, '-' to decrease value **" << endl;
  	mode = 4;
	}
	break;
  case 'f' :
  if (mode!=8) {
  	cout << "** MAX FORCE mode - use '+' to increase value, '-' to decrease value **" << endl;
  	mode = 5;
  	}
	break;
  case 'v' :
  if (mode!=8) {
  	cout << "** MAX VELOCITY mode - use '+' to increase value, '-' to decrease value **" << endl;
  	mode = 6;
	}
  	break;
  }
	glutPostRedisplay();
}

/// handles a key release of the normals keys
void OnKeyRelease(unsigned char key,int x,int y) {
	glutPostRedisplay();
}

/// handles a key press of the special keys
void OnSpecialKeyPress(int key,int x,int y) {
    switch (key)
    {
    // slide the camera left right up and down
    case GLUT_KEY_LEFT	:
	break;
    case GLUT_KEY_UP	:
	break;
	case GLUT_KEY_RIGHT	:
    break;
	case GLUT_KEY_DOWN	:
	break;
    //slide the camera along the z axis
	case GLUT_KEY_PAGE_UP	:
		break;
	case GLUT_KEY_PAGE_DOWN	:
		break;

    }

	glutPostRedisplay();
}

/// handles a key release of the special keys
void OnSpecialKeyRelease(int key,int x,int y) {
	glutPostRedisplay();
}

void OnIdle() {
	glutPostRedisplay();
}

/// the main entry point of the app....
int main(int argc,char** argv) {
	if (argc>1) {
		mode = 8; //set the mode to be map
		theMap = argv[1];
	} else {
		mode = 0;
		theMap = "";
	}
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH|GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize((int)(WIN_HEIGHT*theUniverse.globalMap.aspectRatio), WIN_HEIGHT);
	glutCreateWindow("xymosBot control Example");

	// register callback functions
	glutDisplayFunc(OnDraw);
	glutIdleFunc(OnIdle);
	glutReshapeFunc(OnResize);
	glutKeyboardFunc(OnKeyPress);
	glutKeyboardUpFunc(OnKeyRelease);
	glutSpecialFunc(OnSpecialKeyPress);
	glutSpecialUpFunc(OnSpecialKeyRelease);
	glutMouseFunc(OnMouseButton);
	glutMotionFunc(OnMouseMove);
	glutPassiveMotionFunc(OnMousePassive);

	// register the exit function
	atexit(OnExit);

	// call custom initialisation
	OnInit();

	// enter the main loop for the application
	glutMainLoop();

	return 0;
}
